import { NextApiRequest, NextApiResponse } from "next";
declare function shuffleArray(a: any): any;
declare function chunkArray(arr: any[], size: number): any[];
declare function ensureArray(arr?: any): any[];
declare function random(min: any, max: any): number;
declare function hook(_this: any, method: any, callback: any): (...args: any[]) => any;
declare function sleep(ms: any): Promise<unknown>;
declare function getRandomChars(n: any, chars?: string): string;
declare function request(method: string, url: string, body: string | undefined, headers?: object): Promise<{
    ok: boolean;
    status: number;
    data?: any;
    error?: any;
}>;
declare function httpGet(url: string, params?: object, headers?: object): Promise<{
    ok: boolean;
    status: number;
    data?: any;
    error?: any;
}>;
declare function httpDelete(url: string, params?: object, headers?: object): Promise<{
    ok: boolean;
    status: number;
    data?: any;
    error?: any;
}>;
declare function httpPost(url: string, params?: object, headers?: object): Promise<{
    ok: boolean;
    status: number;
    data?: any;
    error?: any;
}>;
declare function httpPut(url: string, params?: object, headers?: object): Promise<{
    ok: boolean;
    status: number;
    data?: any;
    error?: any;
}>;
declare function setItem(key: string, data: any, session?: boolean): void;
declare function getItem(key: string, session?: boolean): any;
declare function removeItem(key: string, session?: boolean): void;
declare function getQueryString(params?: object): string;
declare function buildUrl(url: string, params?: object): string;
declare function safeDecodeURI(s: string | undefined | null): string | undefined | null;
declare function safeDecodeURIComponent(s: string | undefined | null): string | undefined | null;
type ApiResponse<T> = {
    ok: boolean;
    status: number;
    data?: T;
    error?: any;
};
type ApiMethod = (url: string, params?: any, headers?: any) => Promise<ApiResponse<any>>;
interface ApiMethods {
    get: ApiMethod;
    post: ApiMethod;
    put: ApiMethod;
    del: ApiMethod;
}
declare function useApi(defaultHeaders?: any, basePath?: string): ApiMethods;
declare function encrypt(value: any, secret: any): string;
declare function decrypt(value: any, secret: any): string;
declare function hash(...args: string[]): string;
declare function md5(...args: string[]): string;
type MiddlewareFunction = (req: NextApiRequest, res: NextApiResponse, result?: any) => void;
declare function createMiddleware(middleware: MiddlewareFunction): (req: NextApiRequest, res: NextApiResponse) => Promise<unknown>;
declare function hashPassword(password: string, rounds?: number): any;
declare function checkPassword(password: string, passwordHash: string): any;
declare function ok(res: NextApiResponse, data?: object): void;
declare function json(res: NextApiResponse, data?: object): void;
declare function send(res: NextApiResponse, data: any, type?: string): void;
declare function redirect(res: NextApiResponse, url: string): NextApiResponse<any>;
declare function badRequest(res: NextApiResponse, msg?: string): NextApiResponse<any>;
declare function unauthorized(res: NextApiResponse, msg?: string): NextApiResponse<any>;
declare function forbidden(res: NextApiResponse, msg?: string): NextApiResponse<any>;
declare function notFound(res: NextApiResponse, msg?: string): NextApiResponse<any>;
declare function methodNotAllowed(res: NextApiResponse, msg?: string): void;
declare function tooManyRequest(res: NextApiResponse, msg?: string): NextApiResponse<any>;
declare function serverError(res: NextApiResponse, msg?: string): void;
declare function createToken(payload: any, secret: any, options?: any): any;
declare function parseToken(token: string, secret: any): any;
declare function createSecureToken(payload: any, secret: any, options?: any): string;
declare function parseSecureToken(token: string, secret: any): any;
declare function parseAuthToken(req: Request, secret: string): Promise<any>;
export { shuffleArray, chunkArray, ensureArray, random, hook, sleep, getRandomChars, request, httpGet, httpDelete, httpPost, httpPut, setItem, getItem, removeItem, getQueryString, buildUrl, safeDecodeURI, safeDecodeURIComponent, ApiResponse, ApiMethod, ApiMethods, useApi, encrypt, decrypt, hash, md5, MiddlewareFunction, createMiddleware, hashPassword, checkPassword, ok, json, send, redirect, badRequest, unauthorized, forbidden, notFound, methodNotAllowed, tooManyRequest, serverError, createToken, parseToken, createSecureToken, parseSecureToken, parseAuthToken };
